/****************************************************************************
 * (c) 2019 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * Luftdruck, Luftfeuchte und Temperatur messen und auf einem eInk Display ausgeben
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <avr/wdt.h>
#include <avr/sleep.h>
#include <Narcoleptic.h>
#include "eink_display.h"
#include "bmp280.h"

// Defines
//#define HWDEBUG

// Funktionen
void setup() 
{
  // HW Debug: rote LED an Pin3 und gruene LED an Pin2
#ifdef HWDEBUG
  pinMode(2, OUTPUT); // LED ERROR
  digitalWrite(2, LOW);
  pinMode(3, OUTPUT); // LED OK
  digitalWrite(3,LOW);
#endif
  
  // EPD eInk Display
  if (EINK_ERROR == eInk_Init())
  {
  }
  else
  {
  }

  // Sensor
  if (BMP280_ERR == BMP280_Setup())
  {
#ifdef HWDEBUG    
    digitalWrite(3, HIGH);
#endif    
  }
  else
  {
#ifdef HWDEBUG    
    digitalWrite(2, HIGH);
#endif
  }  

  //Narcoleptic Schlafmodus
  Narcoleptic.disableTimer1();
  Narcoleptic.disableTimer2();
  Narcoleptic.disableSerial();
//  Narcoleptic.disableADC();  // !!! enabling this causes >100uA consumption !!!
  // Another tweaks to lower the power consumption
  ADCSRA &= ~(1<<ADEN); //Disable ADC
  ACSR = (1<<ACD); //Disable the analog comparator
  //
  // ATmega48/88/168/328
//  DIDR0 = B00111111; //Disable digital input buffers on all ADC0-ADC5 pins
//  DIDR1 = (1<<AIN1D)|(1<<AIN0D); //Disable digital input buffer on AIN1/0
  //
  // ATtiny25/45/85
//  Disable digital input buffers on all ADC0,ADC2,ADC3 + AIN1/0 pins
//  DIDR0 = (1<<ADC0D)|(1<<ADC2D)|(1<<ADC3D)|(1<<AIN1D)|(1<<AIN0D);
}

void loop() 
{
  eInk_MesswerteSetzen(BMP280_ReadTemperature(), BMP280_ReadHumidity(), BMP280_ReadPressure());
  eInk_MesswerteAusgeben();
  Narcoleptic.delay(60000); // 1min schlafend warten
}
