/****************************************************************************
 * (c) 2019 softwareentwicklung-als-prozess.de
 * Funktionalitaet:
 * Sensor fuer Luftdruck, Temperatur und Luftfeuchte
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
#include "bmp280.h"

// Defines ------------------------------------------------------------------
#define I2C_ADDRESS (uint8_t)0x76

// Variablen ----------------------------------------------------------------
Adafruit_BME280 bme;         // I2C
// interne Prototypen -------------------------------------------------------

// Funktionen ---------------------------------------------------------------
int BMP280_Setup(void) 
{
    int retval = BMP280_OK;

    if ((bool)false == bme.begin(I2C_ADDRESS)) 
    {
        retval = BMP280_ERR; // keinen Sensor gefunden
    }
    return(retval);
}

float BMP280_ReadTemperature(void) // in Grad Celsius
{
  return(bme.readTemperature());
}

float BMP280_ReadPressure(void) // in hektoPascal hPa
{
  return(bme.readPressure() / 100.0F);
}

float BMP280_ReadHumidity(void)
{
  return(bme.readHumidity());
}
